﻿#define PORT         23
#define SERVER_IP    TCP_IPADDR(10,0,8,25)
#define TIMEOUT      500
#define BUF_LEN      64

static tHandle h = INVALID_HANDLE;  // handle for TCP Communications
int index = 0;          // timer execution count
int missingCount = 0;   // the missing count (receiving error count)

void BitButton5OnClick(tWidget *pWidget) // Start
{
  if ( h > INVALID_HANDLE ) return; // already have a connection

  // Allocate a session. Check if h < 0 to prevent using another tHandle
  h = hmi_TCPNew();      //Allocate a TCP session if possible

  if (h > INVALID_HANDLE)  // if allocating a new session successfully
  {
     LabelTextSet(&Label4, "Connecting");
     //used in a client to establish a TCP session for connecting to a server.
     hmi_TCPOpen(h, SERVER_IP, PORT, PORT);
  }
  else
     h = INVALID_HANDLE; // don't keep error code in h

  TimerEnabledSet(&Timer10, 1); // Enable checking connection status
}

void BitButton6OnClick(tWidget *pWidget)   // Stop
{
  if (h > INVALID_HANDLE)
  {
    hmi_TCPClose(h);  //closes and deallocates a TCP session.
    h = INVALID_HANDLE;
    LabelTextSet(&Label4, "OFF");
  }
}

void TestData()       //Send data
{
  static unsigned char send_buf[BUF_LEN];
  static unsigned char recv_buf[BUF_LEN];

  if ( h == INVALID_HANDLE ) return; // not ready yet

  index++;

  if (hmi_TCPState(h) == STATE_TCP_CONNECTED)
  {
     usprintf((char*)send_buf, "DATA%05d", index);
     //sends data and then receives data through a TCP session.
     hmi_TCPSendCmdEx(h, send_buf, BUF_LEN, recv_buf, BUF_LEN, TIMEOUT);
     recv_buf[BUF_LEN -1] = 0;     // null-terminated
     LabelTextSet(&Label12, (char*)send_buf);
  }
}

void Timer10OnExecute(tWidget *pWidget)     // State machine operations
{
  static int iOperation = 0;

  switch (iOperation)
  {
    case 0:  // Data transmission
    {
      if (hmi_TCPState(h) == STATE_TCP_CONNECTED)          //gets the state of the TCP session.
      {
         LabelTextSet(&Label9, "CONNECTED");
         LabelTextSet(&Label4, "ON");
         TestData();
         iOperation++;
      }
      break;
    }
    case 1:  // Disconnecting
    {
      BitButton6OnClick(pWidget);   // Stop
      LabelTextSet(&Label9, "DISCONNECTED");
      iOperation++;
      break;
    }
    case 2:  // Reconnect
    {
      BitButton5OnClick(pWidget); // reconnect
      iOperation = 0;
      break;
    }
    default:
      break;
  }
}