#ifndef __HMI_ROM_API_H
#define __HMI_ROM_API_H

#include "svchandler.h"

#define HMI_ROM_API

#ifdef MAIN_ENTRY
  #define EXTERN /**/
#else
  #define EXTERN extern
#endif  


#define O_PORTRAIT       0
#define O_LANDSCAPE      1
#define O_PORTRAIT_FLIP  2
#define O_LANDSCAPE_FLIP 3

#define HMI_WIDGET_INIT() hmi_Widget_Init()

#ifdef HMI_ROM_API
  EXTERN tDisplay g_sDisplayDriverROM;
  #define HMI_ROM_HANDLER_ADDR 		(*(unsigned long *)(0x1800+0x2C))
  #define HMI_ROM_HANDLER_PTR 		((tSVCHandler *)HMI_ROM_HANDLER_ADDR)
  #define HMI_DISPLAY_DRIVER_PTR 	(&g_sDisplayDriverROM)

  #define HMI_DISPLAY_INIT(orient) 			\
  do {\
	switch(orient) { \
      case O_PORTRAIT: \
        HMI_ROM_HANDLER_PTR->pGrLib->pfnPortraitDisplayInit(); \
	    memcpy(HMI_DISPLAY_DRIVER_PTR, HMI_ROM_HANDLER_PTR->pGrLib->pPortraitDisplay - 0x20000000, sizeof(tDisplay)); break;\
      case O_LANDSCAPE: \
        HMI_ROM_HANDLER_PTR->pGrLib->pfnLandscapeDisplayInit(); \
	    memcpy(HMI_DISPLAY_DRIVER_PTR, HMI_ROM_HANDLER_PTR->pGrLib->pLandscapeDisplay - 0x20000000, sizeof(tDisplay)); break;\
      case O_PORTRAIT_FLIP: \
        HMI_ROM_HANDLER_PTR->pGrLib->pfnPortraitFlipDisplayInit(); \
	    memcpy(HMI_DISPLAY_DRIVER_PTR, HMI_ROM_HANDLER_PTR->pGrLib->pPortraitFlipDisplay - 0x20000000, sizeof(tDisplay)); break;\
      case O_LANDSCAPE_FLIP: \
        HMI_ROM_HANDLER_PTR->pGrLib->pfnLandscapeFlipDisplayInit(); \
	    memcpy(HMI_DISPLAY_DRIVER_PTR, HMI_ROM_HANDLER_PTR->pGrLib->pLandscapeFlipDisplay - 0x20000000, sizeof(tDisplay)); break;\
	} \
	HMI_WIDGET_INIT(); \
  } while(0)
  
#else
  #define HMI_DISPLAY_INIT() 		SSD1963_480x272_Init()
  #define HMI_DISPLAY_DRIVER_PTR 	(&g_sSSD1963_480x272)
#endif


#endif
