﻿#include "hmiworks.h"
BYTE ladder_main(BYTE);

int g_hmi_CurrentFrame = 0;
static int s_hmi_tcp_inited = 0;

const char *g_FrameNames[] = 
{
  "Frame1",
  "Frame2",
  "Frame3",
  "Frame4",
};

const int g_FrameCount = (sizeof(g_FrameNames)/sizeof(char *));

#define MAGIC_NUM_TO_CON		472882027

HANDLE UART;
HANDLE I_7065_1;
HANDLE I_7018Z_2;

void CheckModbus()
{
}

void _tpd_tcp_initial()
{
   if ( !lwIPLocalIPAddrGet() ) return;


   s_hmi_tcp_inited = 1;
}

volatile unsigned long g_TimerTicksCount = 0;
unsigned long g_ulTickTmrEvtTrig = 0;

static volatile bool I_7065_1_flag = false;
static volatile bool I_7018Z_2_flag = false;

void hmi_TimerTrigger()
{
  g_TimerTicksCount++;
  
  if ((g_TimerTicksCount%(100/10)) == 0)
  I_7065_1_flag = true ;
  
  if ((g_TimerTicksCount%(100/10)) == 0)
  I_7018Z_2_flag = true ;
  
  if (table_init_flag && (g_TimerTicksCount%(100/10)) == 0)
  { g_ulTickTmrEvtTrig = g_TimerTicksCount;
    AddQueueMessage(0);}
  
  if ( s_hmi_tcp_inited ) {
     if ((g_TimerTicksCount%50) == 0) CheckModbus();
  } else if ( g_TimerTicksCount > 80 )
     _tpd_tcp_initial();
  
  switch(g_hmi_CurrentFrame) {
    case 1: {
    break;
    }
    case 2: {
    break;
    }
    case 3: {
    break;
    }
    case 4: {
    break;
    }
  }
}

void hmi_FreeCurrentFrame()
{
  switch (g_hmi_CurrentFrame)
  {
	case 1: hmi_FreeFrameWidgets1(); break;
	case 2: hmi_FreeFrameWidgets2(); break;
	case 3: hmi_FreeFrameWidgets3(); break;
	case 4: hmi_FreeFrameWidgets4(); break;
  }
}

void hmi_GetActiveFrame(char* str, unsigned int len)
{
 int FNLen = strlen(g_FrameNames[g_hmi_CurrentFrame-1]);
 if(len >= FNLen)
 memcpy(str, g_FrameNames[g_hmi_CurrentFrame-1], FNLen);
}

void hmi_GotoFrame(int nFrame)
{

  switch(nFrame)
  {
	case 1: hmi_Frame1(); break;
	case 2: hmi_Frame2(); break;
	case 3: hmi_Frame3(); break;
	case 4: hmi_Frame4(); break;
  }

  WidgetMessageQueueClear();
  WidgetPaint(WIDGET_ROOT);
}

int hmi_IndexOfFrame(const char *frame_name)
{
   int i;
   for (i=0; i<g_FrameCount; i++)
      if (strcmp(frame_name, g_FrameNames[i]) == 0) return i+1;
   return 0;
}


void hmi_GotoFrameByName(const char *frame_name)
{
   hmi_GotoFrame(hmi_IndexOfFrame(frame_name));
}

long hmi_Ladder_Process(tWidget *pWidget, unsigned long ulMessage,
                     unsigned long ulParam1, unsigned long ulParam2)

{
  ladder_main(1);
  passDataThruBindingOnChange();
  default_output(1);
  return 1;
}


BYTE polling_I_7065_1(BYTE en)
{
  if ( !VAR_VALUE(I_7065_1_ENABLE_DEVICE) ) return 0;
BEGIN_FUNCTION_BLOCK();

DWORD v_do = 0;
DWORD v_di = 0;
int   gWriteCount = 0;

uart_SetTimeout(I_7065_1, 200);

if ( VAR_VALUE(I_7065_1_ENABLE_DO) && VAR_VALUE(I_7065_1_W_ACTION)) 
{
   int iWrite = 0;
   v_do   = 0;
    
   iWrite += VAR_GET_WRITE_U32(&v_do, I_7065_1_DO0, 0);
   iWrite += VAR_GET_WRITE_U32(&v_do, I_7065_1_DO1, 1);
   iWrite += VAR_GET_WRITE_U32(&v_do, I_7065_1_DO2, 2);
   iWrite += VAR_GET_WRITE_U32(&v_do, I_7065_1_DO3, 3);
   iWrite += VAR_GET_WRITE_U32(&v_do, I_7065_1_DO4, 4);
   
   if ( iWrite )  // Write only when need
   {
      gWriteCount++;
      if ( ! dcon_WriteDO(I_7065_1, 1, 5, v_do & 0xFF) )
	      return HMI_ERROR;
   }
}

if ( gWriteCount ) return HMI_OK;  // Skip reading to reduce the device loading 

if ( (VAR_VALUE(I_7065_1_ENABLE_DO) || VAR_VALUE(I_7065_1_ENABLE_DI)) && VAR_VALUE(I_7065_1_R_ACTION)) { 
if (dcon_ReadDIO(I_7065_1, 1, 4, 5, &v_di, &v_do))
{
	VAR_SET(I_7065_1_DI0, (v_di>>0) & 1);
	VAR_SET(I_7065_1_DI1, (v_di>>1) & 1);
	VAR_SET(I_7065_1_DI2, (v_di>>2) & 1);
	VAR_SET(I_7065_1_DI3, (v_di>>3) & 1);

	VAR_SET(I_7065_1_DO0, (v_do>>0) & 1);
	VAR_SET(I_7065_1_DO1, (v_do>>1) & 1);
	VAR_SET(I_7065_1_DO2, (v_do>>2) & 1);
	VAR_SET(I_7065_1_DO3, (v_do>>3) & 1);
	VAR_SET(I_7065_1_DO4, (v_do>>4) & 1);
} else 
    return HMI_ERROR;
}

END_FUNCTION_BLOCK();

  return 0;
}

BYTE polling_I_7018Z_2(BYTE en)
{
  if ( !VAR_VALUE(I_7018Z_2_ENABLE_DEVICE) ) return 0;
BEGIN_FUNCTION_BLOCK();

float v_ai[10];
int   iRtn;

uart_SetTimeout(I_7018Z_2, 200);

if ( VAR_VALUE(I_7018Z_2_ENABLE_AI) && VAR_VALUE(I_7018Z_2_R_ACTION)) 
{ 
  iRtn = dcon_ReadAIAll(I_7018Z_2, 2, v_ai);
  VAR_SET(I_7018Z_2_AI0, v_ai[0]);
  VAR_SET(I_7018Z_2_AI1, v_ai[1]);
  VAR_SET(I_7018Z_2_AI2, v_ai[2]);
  VAR_SET(I_7018Z_2_AI3, v_ai[3]);
  VAR_SET(I_7018Z_2_AI4, v_ai[4]);
  VAR_SET(I_7018Z_2_AI5, v_ai[5]);
  VAR_SET(I_7018Z_2_AI6, v_ai[6]);
  VAR_SET(I_7018Z_2_AI7, v_ai[7]);
  VAR_SET(__UNDEFINED__, v_ai[8]);
  VAR_SET(__UNDEFINED__, v_ai[9]);

  if ( ! iRtn ) 
    return HMI_ERROR;
}

END_FUNCTION_BLOCK();

  return 0;
}


void hmi_Connection_Process0(void)
{
  static unsigned int polling_module=0;
  switch(polling_module++%2) {
  case 0:
  if (I_7065_1_flag)
  {
    VAR_SET(I_7065_1_ERROR, polling_I_7065_1(1)? 1:0);
    I_7065_1_flag = false ;
  }
  break;

  case 1:
  if (I_7018Z_2_flag)
  {
    VAR_SET(I_7018Z_2_ERROR, polling_I_7018Z_2(1)? 1:0);
    I_7018Z_2_flag = false ;
  }
  break;

  default: break;
  } //end switch

}

BYTE Polling_Get_Error_State(BYTE en, tHandle mtconn, sMTMaster* mtmdev)
{
  mtmdev->preerrsta = mtmdev->errsta;
  switch (hmi_TCPState(mtconn))
  {
  default:
  case STATE_TCP_IDLE:
    mtmdev->errsta = 1;
    break;
  case STATE_TCP_LISTEN:
    mtmdev->errsta = 1;
    break;
  case STATE_TCP_CONNECTING:
    if(g_ulTickTmrEvtTrig%(500/10) == 0){
    if (mtmdev->preerrsta == 2)
    mtmdev->errsta = 3;
    else if (mtmdev->preerrsta == 3)
    mtmdev->errsta = 2;
    else 
    {
    mtmdev->errsta = 2;
    mtmdev->preerrsta = 2;
    }
    } break;
  case STATE_TCP_CONNECTED:
    if (en > 0)
    mtmdev->errsta = 1;
    else
    mtmdev->errsta = 0;
    break;
    }
  return mtmdev->errsta;
}

void hmi_IOScan_Process(void)
{
  if ( s_hmi_tcp_inited )
  {
  } else {
  }


  static unsigned int polling_connection=0;
  switch(polling_connection++%1) {
  case 0:
  hmi_Connection_Process0(); break;

  default: break;
  } //end switch

  default_input(1);
}

void hmi_frame0()
{
  tContext sContext;
  UART = uart_Open("COM1,9600,N,8,1");
  I_7065_1 = UART;
  I_7018Z_2 = UART;
  
  RegisterNullWidgetMsgProc(hmi_Ladder_Process);
  
  hmi_grlib_init(HMI_GRLIB_INIT_BASIC);
  GrContextInit(&sContext, HMI_DISPLAY_DRIVER_PTR);
  hmi_GotoFrame(1);
  GrFlush(&sContext);
}
