﻿#include "hmiworks.h"
BYTE ladder_main(BYTE);

int g_hmi_CurrentFrame = 0;
static int s_hmi_tcp_inited = 0;

const char *g_FrameNames[] = 
{
  "Frame1",
};

const int g_FrameCount = (sizeof(g_FrameNames)/sizeof(char *));

#define MAGIC_NUM_TO_CON		472882027

tHandle TCP_10_1_121_123_502;
unsigned long TCP_10_1_121_123_502_RI = 0;
tModbusTCP PET_7018;
#define TCP_10_1_121_123_502_MCNT 1
sMTMaster TCP_10_1_121_123_502_DevArr[TCP_10_1_121_123_502_MCNT];

void CheckModbus()
{
  MODBUS_CHECK(PET_7018);
}

void _tpd_tcp_initial()
{
	TCP_10_1_121_123_502_DevArr[0].Dev = &PET_7018;
   if ( !lwIPLocalIPAddrGet() ) return;

   MODBUS_REGISTER_TCP(TCP_10_1_121_123_502, TCP_IPADDR(10,1,121,123), 502);
   MODBUS_REGISTER_BY_HANDLE(PET_7018, TCP_10_1_121_123_502, 1);
   MODBUS_WAIT(PET_7018);

   TCP_10_1_121_123_502_RI = 0;

   s_hmi_tcp_inited = 1;
}

volatile unsigned long g_TimerTicksCount = 0;
unsigned long g_ulTickTmrEvtTrig = 0;

static volatile bool PET_7018_flag = false;

void hmi_TimerTrigger()
{
  g_TimerTicksCount++;
  
  if ((g_TimerTicksCount%(100/10)) == 0)
  PET_7018_flag = true ;
  
  if (table_init_flag && (g_TimerTicksCount%(100/10)) == 0)
  { g_ulTickTmrEvtTrig = g_TimerTicksCount;
    AddQueueMessage(0);}
  
  if ( s_hmi_tcp_inited ) {
     if ((g_TimerTicksCount%50) == 0) CheckModbus();
  } else if ( g_TimerTicksCount > 80 )
     _tpd_tcp_initial();
  
  switch(g_hmi_CurrentFrame) {
    case 1: {
    break;
    }
  }
}

void hmi_FreeCurrentFrame()
{
  switch (g_hmi_CurrentFrame)
  {
	case 1: hmi_FreeFrameWidgets1(); break;
  }
}

void hmi_GetActiveFrame(char* str, unsigned int len)
{
 int FNLen = strlen(g_FrameNames[g_hmi_CurrentFrame-1]);
 if(len >= FNLen)
 memcpy(str, g_FrameNames[g_hmi_CurrentFrame-1], FNLen);
}

void hmi_GotoFrame(int nFrame)
{

  switch(nFrame)
  {
	case 1: hmi_Frame1(); break;
  }

  WidgetMessageQueueClear();
  WidgetPaint(WIDGET_ROOT);
}

int hmi_IndexOfFrame(const char *frame_name)
{
   int i;
   for (i=0; i<g_FrameCount; i++)
      if (strcmp(frame_name, g_FrameNames[i]) == 0) return i+1;
   return 0;
}


void hmi_GotoFrameByName(const char *frame_name)
{
   hmi_GotoFrame(hmi_IndexOfFrame(frame_name));
}

long hmi_Ladder_Process(tWidget *pWidget, unsigned long ulMessage,
                     unsigned long ulParam1, unsigned long ulParam2)

{
  ladder_main(1);
  passDataThruBindingOnChange();
  default_output(1);
  return 1;
}

BYTE polling_PET_7018(BYTE en)
{
  if ( !VAR_VALUE(PET_7018_ENABLE_DEVICE) ) return 0;
  if (MODBUS_CONNECTED(PET_7018)) {

     return HMI_OK;
  }
  return HMI_ERROR;
}





static void DoReconnection_TCP_10_1_121_123_502() {
  switch(hmi_TCPState(TCP_10_1_121_123_502)){
  case STATE_TCP_IDLE:
  TCP_10_1_121_123_502 = -1;
  if ( VAR_VALUE(PET_7018_ENABLE_DEVICE) ) {
    if (0 == TCP_10_1_121_123_502_RI) {
      TCP_10_1_121_123_502_RI = g_ulTickTmrEvtTrig;
    } else if (TCP_10_1_121_123_502_RI > 0) {
      if ((MAGIC_NUM_TO_CON == TCP_10_1_121_123_502_RI) || (g_ulTickTmrEvtTrig - TCP_10_1_121_123_502_RI > (5000 / 10))) {
        MODBUS_REGISTER_TCP(TCP_10_1_121_123_502, TCP_IPADDR(10,1,121,123), 502);
        MODBUS_REGISTER_BY_HANDLE(PET_7018, TCP_10_1_121_123_502, 1);
        MODBUS_WAIT(PET_7018);
        TCP_10_1_121_123_502_RI = 0;
      }
    }
  } else {
    TCP_10_1_121_123_502_RI = MAGIC_NUM_TO_CON;
  } break;
  
  case STATE_TCP_LISTEN:
  break;
  
  default:
  case STATE_TCP_CONNECTING:
  if ( VAR_VALUE(PET_7018_ENABLE_DEVICE) ) {
  ; } else {
    hmi_TCPAbandon(TCP_10_1_121_123_502, 1);
    TCP_10_1_121_123_502 = -1;
    TCP_10_1_121_123_502_RI = MAGIC_NUM_TO_CON;
  } break;
  
  case STATE_TCP_CONNECTED:
  if ( VAR_VALUE(PET_7018_ENABLE_DEVICE) ) {
  TCP_10_1_121_123_502_RI = 0; } else {
    mtm_Unregister(TCP_10_1_121_123_502);
    TCP_10_1_121_123_502 = -1;
    TCP_10_1_121_123_502_RI = MAGIC_NUM_TO_CON;
  } break;
  } // end of switch
}


BYTE Polling_Get_Error_State(BYTE en, tHandle mtconn, sMTMaster* mtmdev)
{
  mtmdev->preerrsta = mtmdev->errsta;
  switch (hmi_TCPState(mtconn))
  {
  default:
  case STATE_TCP_IDLE:
    mtmdev->errsta = 1;
    break;
  case STATE_TCP_LISTEN:
    mtmdev->errsta = 1;
    break;
  case STATE_TCP_CONNECTING:
    if(g_ulTickTmrEvtTrig%(500/10) == 0){
    if (mtmdev->preerrsta == 2)
    mtmdev->errsta = 3;
    else if (mtmdev->preerrsta == 3)
    mtmdev->errsta = 2;
    else 
    {
    mtmdev->errsta = 2;
    mtmdev->preerrsta = 2;
    }
    } break;
  case STATE_TCP_CONNECTED:
    if (en > 0)
    mtmdev->errsta = 1;
    else
    mtmdev->errsta = 0;
    break;
    }
  return mtmdev->errsta;
}

void hmi_IOScan_Process(void)
{
  if ( s_hmi_tcp_inited )
  {
    DoReconnection_TCP_10_1_121_123_502();
    if (PET_7018_flag)
    {
      VAR_SET(PET_7018_ERROR, Polling_Get_Error_State(polling_PET_7018(1), TCP_10_1_121_123_502, &TCP_10_1_121_123_502_DevArr[0]));
      PET_7018_flag = false ;
    }

  } else {
    VAR_SET(PET_7018_ERROR, 1);
  }


  default_input(1);
}

void hmi_frame0()
{
  tContext sContext;
  
  RegisterNullWidgetMsgProc(hmi_Ladder_Process);
  
  hmi_grlib_init(HMI_GRLIB_INIT_BASIC);
  GrContextInit(&sContext, HMI_DISPLAY_DRIVER_PTR);
  hmi_GotoFrame(1);
  GrFlush(&sContext);
}
