﻿#include "hmiworks.h"
BYTE ladder_main(BYTE);

int g_hmi_CurrentFrame = 0;
static int s_hmi_tcp_inited = 0;

const char *g_FrameNames[] = 
{
  "Frame1",
};

const int g_FrameCount = (sizeof(g_FrameNames)/sizeof(char *));

#define MAGIC_NUM_TO_CON		472882027

tHandle TCPIP_1;
unsigned long TCPIP_1_RI = 0;
tModbusTCP Dev_PET_7053_1;
#define TCPIP_1_MCNT 1
sMTMaster TCPIP_1_DevArr[TCPIP_1_MCNT];

void CheckModbus()
{
  MODBUS_CHECK(Dev_PET_7053_1);
}

void _tpd_tcp_initial()
{
	TCPIP_1_DevArr[0].Dev = &Dev_PET_7053_1;
   if ( !lwIPLocalIPAddrGet() ) return;

   MODBUS_REGISTER_TCP(TCPIP_1, TCP_IPADDR(192,168,8,225), 502);
   MODBUS_REGISTER_BY_HANDLE(Dev_PET_7053_1, TCPIP_1, 1);
   MODBUS_WAIT(Dev_PET_7053_1);

   TCPIP_1_RI = 0;

   s_hmi_tcp_inited = 1;
}

volatile unsigned long g_TimerTicksCount = 0;
unsigned long g_ulTickTmrEvtTrig = 0;

static volatile bool Dev_PET_7053_1_flag = false;

void hmi_TimerTrigger()
{
  g_TimerTicksCount++;
  
  if ((g_TimerTicksCount%(100/10)) == 0)
  Dev_PET_7053_1_flag = true ;
  
  if (table_init_flag && (g_TimerTicksCount%(100/10)) == 0)
  { g_ulTickTmrEvtTrig = g_TimerTicksCount;
    AddQueueMessage(0);}
  
  if ( s_hmi_tcp_inited ) {
     if ((g_TimerTicksCount%50) == 0) CheckModbus();
  } else if ( g_TimerTicksCount > 80 )
     _tpd_tcp_initial();
  
  switch(g_hmi_CurrentFrame) {
    case 1: {
    break;
    }
  }
}

void hmi_FreeCurrentFrame()
{
  switch (g_hmi_CurrentFrame)
  {
	case 1: hmi_FreeFrameWidgets1(); break;
  }
}

void hmi_GetActiveFrame(char* str, unsigned int len)
{
 int FNLen = strlen(g_FrameNames[g_hmi_CurrentFrame-1]);
 if(len >= FNLen)
 memcpy(str, g_FrameNames[g_hmi_CurrentFrame-1], FNLen);
}

void hmi_GotoFrame(int nFrame)
{

  switch(nFrame)
  {
	case 1: hmi_Frame1(); break;
  }

  WidgetMessageQueueClear();
  WidgetPaint(WIDGET_ROOT);
}

int hmi_IndexOfFrame(const char *frame_name)
{
   int i;
   for (i=0; i<g_FrameCount; i++)
      if (strcmp(frame_name, g_FrameNames[i]) == 0) return i+1;
   return 0;
}


void hmi_GotoFrameByName(const char *frame_name)
{
   hmi_GotoFrame(hmi_IndexOfFrame(frame_name));
}

long hmi_Ladder_Process(tWidget *pWidget, unsigned long ulMessage,
                     unsigned long ulParam1, unsigned long ulParam2)

{
  ladder_main(1);
  passDataThruBindingOnChange();
  default_output(1);
  return 1;
}

BYTE polling_Dev_PET_7053_1(BYTE en)
{
  if ( !VAR_VALUE(Dev_PET_7053_1_ENABLE_DEVICE) ) return 0;
  if (MODBUS_CONNECTED(Dev_PET_7053_1)) {
BEGIN_FUNCTION_BLOCK();

char v_di[2] = {0};

if (VAR_VALUE(Dev_PET_7053_1_ENABLE_DI) && VAR_VALUE(Dev_PET_7053_1_R_ACTION)) {
   if (MTM_READDI(Dev_PET_7053_1, 1, 0, 16, v_di, 200) ) {
	   VAR_SET(Dev_PET_7053_1_DI0,  (v_di[0] >>0) & 1);
	   VAR_SET(Dev_PET_7053_1_DI1,  (v_di[0] >>1) & 1);
	   VAR_SET(Dev_PET_7053_1_DI2,  (v_di[0] >>2) & 1);
	   VAR_SET(Dev_PET_7053_1_DI3,  (v_di[0] >>3) & 1);
	   VAR_SET(Dev_PET_7053_1_DI4,  (v_di[0] >>4) & 1);
	   VAR_SET(Dev_PET_7053_1_DI5,  (v_di[0] >>5) & 1);
	   VAR_SET(Dev_PET_7053_1_DI6,  (v_di[0] >>6) & 1);
	   VAR_SET(Dev_PET_7053_1_DI7,  (v_di[0] >>7) & 1);
	
	   VAR_SET(Dev_PET_7053_1_DI8,  (v_di[1] >>0) & 1);
	   VAR_SET(Dev_PET_7053_1_DI9,  (v_di[1] >>1) & 1);
	   VAR_SET(Dev_PET_7053_1_DI10, (v_di[1] >>2) & 1);
	   VAR_SET(Dev_PET_7053_1_DI11, (v_di[1] >>3) & 1);
	   VAR_SET(Dev_PET_7053_1_DI12, (v_di[1] >>4) & 1);
	   VAR_SET(Dev_PET_7053_1_DI13, (v_di[1] >>5) & 1);
	   VAR_SET(Dev_PET_7053_1_DI14, (v_di[1] >>6) & 1);
	   VAR_SET(Dev_PET_7053_1_DI15, (v_di[1] >>7) & 1);
  } else
	   return HMI_ERROR;
}
	
END_FUNCTION_BLOCK();

     return HMI_OK;
  }
  return HMI_ERROR;
}





static void DoReconnection_TCPIP_1() {
  switch(hmi_TCPState(TCPIP_1)){
  case STATE_TCP_IDLE:
  TCPIP_1 = -1;
  if ( VAR_VALUE(Dev_PET_7053_1_ENABLE_DEVICE) ) {
    if (0 == TCPIP_1_RI) {
      TCPIP_1_RI = g_ulTickTmrEvtTrig;
    } else if (TCPIP_1_RI > 0) {
      if ((MAGIC_NUM_TO_CON == TCPIP_1_RI) || (g_ulTickTmrEvtTrig - TCPIP_1_RI > (5000 / 10))) {
        MODBUS_REGISTER_TCP(TCPIP_1, TCP_IPADDR(192,168,8,225), 502);
        MODBUS_REGISTER_BY_HANDLE(Dev_PET_7053_1, TCPIP_1, 1);
        MODBUS_WAIT(Dev_PET_7053_1);
        TCPIP_1_RI = 0;
      }
    }
  } else {
    TCPIP_1_RI = MAGIC_NUM_TO_CON;
  } break;
  
  case STATE_TCP_LISTEN:
  break;
  
  default:
  case STATE_TCP_CONNECTING:
  if ( VAR_VALUE(Dev_PET_7053_1_ENABLE_DEVICE) ) {
  ; } else {
    hmi_TCPAbandon(TCPIP_1, 1);
    TCPIP_1 = -1;
    TCPIP_1_RI = MAGIC_NUM_TO_CON;
  } break;
  
  case STATE_TCP_CONNECTED:
  if ( VAR_VALUE(Dev_PET_7053_1_ENABLE_DEVICE) ) {
  TCPIP_1_RI = 0; } else {
    mtm_Unregister(TCPIP_1);
    TCPIP_1 = -1;
    TCPIP_1_RI = MAGIC_NUM_TO_CON;
  } break;
  } // end of switch
}


BYTE Polling_Get_Error_State(BYTE en, tHandle mtconn, sMTMaster* mtmdev)
{
  mtmdev->preerrsta = mtmdev->errsta;
  switch (hmi_TCPState(mtconn))
  {
  default:
  case STATE_TCP_IDLE:
    mtmdev->errsta = 1;
    break;
  case STATE_TCP_LISTEN:
    mtmdev->errsta = 1;
    break;
  case STATE_TCP_CONNECTING:
    if(g_ulTickTmrEvtTrig%(500/10) == 0){
    if (mtmdev->preerrsta == 2)
    mtmdev->errsta = 3;
    else if (mtmdev->preerrsta == 3)
    mtmdev->errsta = 2;
    else 
    {
    mtmdev->errsta = 2;
    mtmdev->preerrsta = 2;
    }
    } break;
  case STATE_TCP_CONNECTED:
    if (en > 0)
    mtmdev->errsta = 1;
    else
    mtmdev->errsta = 0;
    break;
    }
  return mtmdev->errsta;
}

void hmi_IOScan_Process(void)
{
  if ( s_hmi_tcp_inited )
  {
    DoReconnection_TCPIP_1();
    if (Dev_PET_7053_1_flag)
    {
      VAR_SET(Dev_PET_7053_1_ERROR, Polling_Get_Error_State(polling_Dev_PET_7053_1(1), TCPIP_1, &TCPIP_1_DevArr[0]));
      Dev_PET_7053_1_flag = false ;
    }

  } else {
    VAR_SET(Dev_PET_7053_1_ERROR, 1);
  }


  default_input(1);
}

void hmi_frame0()
{
  tContext sContext;
  
  RegisterNullWidgetMsgProc(hmi_Ladder_Process);
  
  hmi_grlib_init(HMI_GRLIB_INIT_BASIC);
  GrContextInit(&sContext, HMI_DISPLAY_DRIVER_PTR);
  hmi_GotoFrame(1);
  GrFlush(&sContext);
}
