﻿#include "hmiworks.h"
BYTE ladder_main(BYTE);

int g_hmi_CurrentFrame = 0;
static int s_hmi_tcp_inited = 0;

const char *g_FrameNames[] = 
{
  "Frame1",
  "Frame2",
  "Frame3",
  "Frame4",
};

const int g_FrameCount = (sizeof(g_FrameNames)/sizeof(char *));

#define MAGIC_NUM_TO_CON		472882027

tHandle TCP_10_1_121_134_502;
unsigned long TCP_10_1_121_134_502_RI = 0;
tHandle TCP_10_1_121_133_502;
unsigned long TCP_10_1_121_133_502_RI = 0;
tModbusTCP PET_7060_1;
tModbusTCP PET_7018Z;
#define TCP_10_1_121_134_502_MCNT 1
sMTMaster TCP_10_1_121_134_502_DevArr[TCP_10_1_121_134_502_MCNT];
#define TCP_10_1_121_133_502_MCNT 1
sMTMaster TCP_10_1_121_133_502_DevArr[TCP_10_1_121_133_502_MCNT];

void CheckModbus()
{
  MODBUS_CHECK(PET_7060_1);
  MODBUS_CHECK(PET_7018Z);
}

void _tpd_tcp_initial()
{
	TCP_10_1_121_134_502_DevArr[0].Dev = &PET_7060_1;
	TCP_10_1_121_133_502_DevArr[0].Dev = &PET_7018Z;
   if ( !lwIPLocalIPAddrGet() ) return;

   MODBUS_REGISTER_TCP(TCP_10_1_121_134_502, TCP_IPADDR(10,1,121,134), 502);
   MODBUS_REGISTER_BY_HANDLE(PET_7060_1, TCP_10_1_121_134_502, 1);
   MODBUS_WAIT(PET_7060_1);

   TCP_10_1_121_134_502_RI = 0;
   MODBUS_REGISTER_TCP(TCP_10_1_121_133_502, TCP_IPADDR(10,1,121,133), 502);
   MODBUS_REGISTER_BY_HANDLE(PET_7018Z, TCP_10_1_121_133_502, 1);
   MODBUS_WAIT(PET_7018Z);

   TCP_10_1_121_133_502_RI = 0;

   s_hmi_tcp_inited = 1;
}

volatile unsigned long g_TimerTicksCount = 0;
unsigned long g_ulTickTmrEvtTrig = 0;

static volatile bool PET_7060_1_flag = false;
static volatile bool PET_7018Z_flag = false;

void hmi_TimerTrigger()
{
  g_TimerTicksCount++;
  
  if ((g_TimerTicksCount%(100/10)) == 0)
  PET_7060_1_flag = true ;
  
  if ((g_TimerTicksCount%(100/10)) == 0)
  PET_7018Z_flag = true ;
  
  if (table_init_flag && (g_TimerTicksCount%(100/10)) == 0)
  { g_ulTickTmrEvtTrig = g_TimerTicksCount;
    AddQueueMessage(0);}
  
  if ( s_hmi_tcp_inited ) {
     if ((g_TimerTicksCount%50) == 0) CheckModbus();
  } else if ( g_TimerTicksCount > 80 )
     _tpd_tcp_initial();
  
  switch(g_hmi_CurrentFrame) {
    case 1: {
    break;
    }
    case 2: {
    break;
    }
    case 3: {
    break;
    }
    case 4: {
    break;
    }
  }
}

void hmi_FreeCurrentFrame()
{
  switch (g_hmi_CurrentFrame)
  {
	case 1: hmi_FreeFrameWidgets1(); break;
	case 2: hmi_FreeFrameWidgets2(); break;
	case 3: hmi_FreeFrameWidgets3(); break;
	case 4: hmi_FreeFrameWidgets4(); break;
  }
}

void hmi_GetActiveFrame(char* str, unsigned int len)
{
 int FNLen = strlen(g_FrameNames[g_hmi_CurrentFrame-1]);
 if(len >= FNLen)
 memcpy(str, g_FrameNames[g_hmi_CurrentFrame-1], FNLen);
}

void hmi_GotoFrame(int nFrame)
{

  switch(nFrame)
  {
	case 1: hmi_Frame1(); break;
	case 2: hmi_Frame2(); break;
	case 3: hmi_Frame3(); break;
	case 4: hmi_Frame4(); break;
  }

  WidgetMessageQueueClear();
  WidgetPaint(WIDGET_ROOT);
}

int hmi_IndexOfFrame(const char *frame_name)
{
   int i;
   for (i=0; i<g_FrameCount; i++)
      if (strcmp(frame_name, g_FrameNames[i]) == 0) return i+1;
   return 0;
}


void hmi_GotoFrameByName(const char *frame_name)
{
   hmi_GotoFrame(hmi_IndexOfFrame(frame_name));
}

long hmi_Ladder_Process(tWidget *pWidget, unsigned long ulMessage,
                     unsigned long ulParam1, unsigned long ulParam2)

{
  ladder_main(1);
  passDataThruBindingOnChange();
  default_output(1);
  return 1;
}

BYTE polling_PET_7060_1(BYTE en)
{
  if ( !VAR_VALUE(PET_7060_1_ENABLE_DEVICE) ) return 0;
  if (MODBUS_CONNECTED(PET_7060_1)) {
BEGIN_FUNCTION_BLOCK();

char v_do = 0;
char v_di = 0;
int  gWriteCount = 0;

// Digital Output
if (VAR_VALUE(PET_7060_1_ENABLE_DO) && VAR_VALUE(PET_7060_W_ACTION)) 
{
   int iWrite = 0;
   v_do   = 0;

   iWrite += VAR_GET_WRITE_BYTE(&v_do, PET_7060_DO0, 0);
   iWrite += VAR_GET_WRITE_BYTE(&v_do, PET_7060_DO1, 1);
   iWrite += VAR_GET_WRITE_BYTE(&v_do, PET_7060_DO2, 2);
   iWrite += VAR_GET_WRITE_BYTE(&v_do, PET_7060_DO3, 3);
   iWrite += VAR_GET_WRITE_BYTE(&v_do, PET_7060_DO4, 4);
   iWrite += VAR_GET_WRITE_BYTE(&v_do, PET_7060_DO5, 5);
  
   if ( iWrite )  // Write only when need
   {
      gWriteCount++;
      if (! MTM_WRITEDO(PET_7060_1, 1, 0, 6, &v_do, 200) )
          return HMI_ERROR;
   }     
}

if ( gWriteCount ) return HMI_OK;  // Skip reading to reduce the device loading 

// Readback Digital Output Status first
v_do = 0;
if (VAR_VALUE(PET_7060_1_ENABLE_DO) && VAR_VALUE(PET_7060_R_ACTION)) { 
if (MTM_READDO(PET_7060_1, 1, 0, 6, &v_do, 200) ) {
	VAR_SET(PET_7060_DO0, (v_do>>0) & 1);
	VAR_SET(PET_7060_DO1, (v_do>>1) & 1);
	VAR_SET(PET_7060_DO2, (v_do>>2) & 1);
	VAR_SET(PET_7060_DO3, (v_do>>3) & 1);
	VAR_SET(PET_7060_DO4, (v_do>>4) & 1);
	VAR_SET(PET_7060_DO5, (v_do>>5) & 1);
} else 
   return HMI_ERROR;
}

// Digital Input
v_di = 0;
if (VAR_VALUE(PET_7060_1_ENABLE_DI) && VAR_VALUE(PET_7060_R_ACTION)) { 
if (MTM_READDI(PET_7060_1, 1, 0, 6, &v_di, 200) ) {
	VAR_SET(PET_7060_DI0, (v_di>>0) & 1);
	VAR_SET(PET_7060_DI1, (v_di>>1) & 1);
	VAR_SET(PET_7060_DI2, (v_di>>2) & 1);
	VAR_SET(PET_7060_DI3, (v_di>>3) & 1);
	VAR_SET(PET_7060_DI4, (v_di>>4) & 1);
	VAR_SET(PET_7060_DI5, (v_di>>5) & 1);
} else
   return HMI_ERROR;
}

END_FUNCTION_BLOCK();

     return HMI_OK;
  }
  return HMI_ERROR;
}

BYTE polling_PET_7018Z(BYTE en)
{
  if ( !VAR_VALUE(PET_7018Z_ENABLE_DEVICE) ) return 0;
  if (MODBUS_CONNECTED(PET_7018Z)) {
BEGIN_FUNCTION_BLOCK();

char  v_do = 0;
WORD  v_ai[10];
int   gWriteCount = 0;

// Write DO
if (VAR_VALUE(PET_7018Z_ENABLE_DO) && VAR_VALUE(PET_7018Z_W_ACTION)) 
{
   int iWrite = 0;
   v_do   = 0;

   iWrite += VAR_GET_WRITE_BYTE(&v_do, PET_7018Z_DO0, 0);
   iWrite += VAR_GET_WRITE_BYTE(&v_do, PET_7018Z_DO1, 1);
   iWrite += VAR_GET_WRITE_BYTE(&v_do, PET_7018Z_DO2, 2);
   iWrite += VAR_GET_WRITE_BYTE(&v_do, PET_7018Z_DO3, 3);
   iWrite += VAR_GET_WRITE_BYTE(&v_do, PET_7018Z_DO4, 4);
   iWrite += VAR_GET_WRITE_BYTE(&v_do, PET_7018Z_DO5, 5);
    
   if ( iWrite )  // Write only when need
   {
      gWriteCount++;
      if ( ! MTM_WRITEDO(PET_7018Z, 1, 0, 6, &v_do, 200) )
         return HMI_ERROR;  
   }
}

if ( gWriteCount ) return HMI_OK;  // Skip reading to reduce the device loading 

if (VAR_VALUE(PET_7018Z_ENABLE_DO) && VAR_VALUE(PET_7018Z_R_ACTION)) { 
	if (MTM_READDO(PET_7018Z, 1, 0, 6, &v_do, 200) ) 
	{
		VAR_SET(PET_7018Z_DO0, (v_do>>0) & 1);
		VAR_SET(PET_7018Z_DO1, (v_do>>1) & 1);
		VAR_SET(PET_7018Z_DO2, (v_do>>2) & 1);
		VAR_SET(PET_7018Z_DO3, (v_do>>3) & 1);
		VAR_SET(PET_7018Z_DO4, (v_do>>4) & 1);
		VAR_SET(PET_7018Z_DO5, (v_do>>5) & 1);
	} else
      return HMI_ERROR;  
}

if (VAR_VALUE(PET_7018Z_ENABLE_AI) &&VAR_VALUE(PET_7018Z_R_ACTION)) { 
	if (MTM_READAI(PET_7018Z, 1, 0, 10, v_ai, 200) ) 
	{
		VAR_SET(PET_7018Z_AI0, v_ai[0]);
		VAR_SET(PET_7018Z_AI1, v_ai[1]);
		VAR_SET(PET_7018Z_AI2, v_ai[2]);
		VAR_SET(PET_7018Z_AI3, v_ai[3]);
		VAR_SET(PET_7018Z_AI4, v_ai[4]);
		VAR_SET(PET_7018Z_AI5, v_ai[5]);
		VAR_SET(PET_7018Z_AI6, v_ai[6]);
		VAR_SET(PET_7018Z_AI7, v_ai[7]);
		VAR_SET(PET_7018Z_AI8, v_ai[8]);
		VAR_SET(PET_7018Z_AI9, v_ai[9]);
	} else
      return HMI_ERROR;  
}
	
END_FUNCTION_BLOCK();

     return HMI_OK;
  }
  return HMI_ERROR;
}






static void DoReconnection_TCP_10_1_121_134_502() {
  switch(hmi_TCPState(TCP_10_1_121_134_502)){
  case STATE_TCP_IDLE:
  TCP_10_1_121_134_502 = -1;
  if ( VAR_VALUE(PET_7060_1_ENABLE_DEVICE) ) {
    if (0 == TCP_10_1_121_134_502_RI) {
      TCP_10_1_121_134_502_RI = g_ulTickTmrEvtTrig;
    } else if (TCP_10_1_121_134_502_RI > 0) {
      if ((MAGIC_NUM_TO_CON == TCP_10_1_121_134_502_RI) || (g_ulTickTmrEvtTrig - TCP_10_1_121_134_502_RI > (5000 / 10))) {
        MODBUS_REGISTER_TCP(TCP_10_1_121_134_502, TCP_IPADDR(10,1,121,134), 502);
        MODBUS_REGISTER_BY_HANDLE(PET_7060_1, TCP_10_1_121_134_502, 1);
        MODBUS_WAIT(PET_7060_1);
        TCP_10_1_121_134_502_RI = 0;
      }
    }
  } else {
    TCP_10_1_121_134_502_RI = MAGIC_NUM_TO_CON;
  } break;
  
  case STATE_TCP_LISTEN:
  break;
  
  default:
  case STATE_TCP_CONNECTING:
  if ( VAR_VALUE(PET_7060_1_ENABLE_DEVICE) ) {
  ; } else {
    hmi_TCPAbandon(TCP_10_1_121_134_502, 1);
    TCP_10_1_121_134_502 = -1;
    TCP_10_1_121_134_502_RI = MAGIC_NUM_TO_CON;
  } break;
  
  case STATE_TCP_CONNECTED:
  if ( VAR_VALUE(PET_7060_1_ENABLE_DEVICE) ) {
  TCP_10_1_121_134_502_RI = 0; } else {
    mtm_Unregister(TCP_10_1_121_134_502);
    TCP_10_1_121_134_502 = -1;
    TCP_10_1_121_134_502_RI = MAGIC_NUM_TO_CON;
  } break;
  } // end of switch
}


static void DoReconnection_TCP_10_1_121_133_502() {
  switch(hmi_TCPState(TCP_10_1_121_133_502)){
  case STATE_TCP_IDLE:
  TCP_10_1_121_133_502 = -1;
  if ( VAR_VALUE(PET_7018Z_ENABLE_DEVICE) ) {
    if (0 == TCP_10_1_121_133_502_RI) {
      TCP_10_1_121_133_502_RI = g_ulTickTmrEvtTrig;
    } else if (TCP_10_1_121_133_502_RI > 0) {
      if ((MAGIC_NUM_TO_CON == TCP_10_1_121_133_502_RI) || (g_ulTickTmrEvtTrig - TCP_10_1_121_133_502_RI > (5000 / 10))) {
        MODBUS_REGISTER_TCP(TCP_10_1_121_133_502, TCP_IPADDR(10,1,121,133), 502);
        MODBUS_REGISTER_BY_HANDLE(PET_7018Z, TCP_10_1_121_133_502, 1);
        MODBUS_WAIT(PET_7018Z);
        TCP_10_1_121_133_502_RI = 0;
      }
    }
  } else {
    TCP_10_1_121_133_502_RI = MAGIC_NUM_TO_CON;
  } break;
  
  case STATE_TCP_LISTEN:
  break;
  
  default:
  case STATE_TCP_CONNECTING:
  if ( VAR_VALUE(PET_7018Z_ENABLE_DEVICE) ) {
  ; } else {
    hmi_TCPAbandon(TCP_10_1_121_133_502, 1);
    TCP_10_1_121_133_502 = -1;
    TCP_10_1_121_133_502_RI = MAGIC_NUM_TO_CON;
  } break;
  
  case STATE_TCP_CONNECTED:
  if ( VAR_VALUE(PET_7018Z_ENABLE_DEVICE) ) {
  TCP_10_1_121_133_502_RI = 0; } else {
    mtm_Unregister(TCP_10_1_121_133_502);
    TCP_10_1_121_133_502 = -1;
    TCP_10_1_121_133_502_RI = MAGIC_NUM_TO_CON;
  } break;
  } // end of switch
}


BYTE Polling_Get_Error_State(BYTE en, tHandle mtconn, sMTMaster* mtmdev)
{
  mtmdev->preerrsta = mtmdev->errsta;
  switch (hmi_TCPState(mtconn))
  {
  default:
  case STATE_TCP_IDLE:
    mtmdev->errsta = 1;
    break;
  case STATE_TCP_LISTEN:
    mtmdev->errsta = 1;
    break;
  case STATE_TCP_CONNECTING:
    if(g_ulTickTmrEvtTrig%(500/10) == 0){
    if (mtmdev->preerrsta == 2)
    mtmdev->errsta = 3;
    else if (mtmdev->preerrsta == 3)
    mtmdev->errsta = 2;
    else 
    {
    mtmdev->errsta = 2;
    mtmdev->preerrsta = 2;
    }
    } break;
  case STATE_TCP_CONNECTED:
    if (en > 0)
    mtmdev->errsta = 1;
    else
    mtmdev->errsta = 0;
    break;
    }
  return mtmdev->errsta;
}

void hmi_IOScan_Process(void)
{
  if ( s_hmi_tcp_inited )
  {
    DoReconnection_TCP_10_1_121_134_502();
    DoReconnection_TCP_10_1_121_133_502();
    if (PET_7060_1_flag)
    {
      VAR_SET(PET_7060_1_ERROR, Polling_Get_Error_State(polling_PET_7060_1(1), TCP_10_1_121_134_502, &TCP_10_1_121_134_502_DevArr[0]));
      PET_7060_1_flag = false ;
    }

    if (PET_7018Z_flag)
    {
      VAR_SET(PET_7018Z_ERROR, Polling_Get_Error_State(polling_PET_7018Z(1), TCP_10_1_121_133_502, &TCP_10_1_121_133_502_DevArr[0]));
      PET_7018Z_flag = false ;
    }

  } else {
    VAR_SET(PET_7060_1_ERROR, 1);
    VAR_SET(PET_7018Z_ERROR, 1);
  }


  default_input(1);
}

void hmi_frame0()
{
  tContext sContext;
  
  RegisterNullWidgetMsgProc(hmi_Ladder_Process);
  
  hmi_grlib_init(HMI_GRLIB_INIT_BASIC);
  GrContextInit(&sContext, HMI_DISPLAY_DRIVER_PTR);
  hmi_GotoFrame(1);
  GrFlush(&sContext);
}
