﻿#include "hmiworks.h"
BYTE ladder_main(BYTE);

int g_hmi_CurrentFrame = 0;
static int s_hmi_tcp_inited = 0;

const char *g_FrameNames[] = 
{
  "Frame1",
  "Frame2",
  "Frame3",
  "Frame4",
  "Frame5",
};

const int g_FrameCount = (sizeof(g_FrameNames)/sizeof(char *));

#define MAGIC_NUM_TO_CON		472882027

HANDLE UART;
HANDLE PM_2133_1;

void CheckModbus()
{
}

void _tpd_tcp_initial()
{
   if ( !lwIPLocalIPAddrGet() ) return;


   s_hmi_tcp_inited = 1;
}

volatile unsigned long g_TimerTicksCount = 0;
unsigned long g_ulTickTmrEvtTrig = 0;

static volatile bool PM_2133_1_flag = false;

void hmi_TimerTrigger()
{
  g_TimerTicksCount++;
  
  if ((g_TimerTicksCount%(100/10)) == 0)
  PM_2133_1_flag = true ;
  
  if (table_init_flag && (g_TimerTicksCount%(100/10)) == 0)
  { g_ulTickTmrEvtTrig = g_TimerTicksCount;
    AddQueueMessage(0);}
  
  if ( s_hmi_tcp_inited ) {
     if ((g_TimerTicksCount%50) == 0) CheckModbus();
  } else if ( g_TimerTicksCount > 80 )
     _tpd_tcp_initial();
  
  switch(g_hmi_CurrentFrame) {
    case 1: {
    break;
    }
    case 2: {
    break;
    }
    case 3: {
    break;
    }
    case 4: {
    break;
    }
    case 5: {
    break;
    }
  }
}

void hmi_FreeCurrentFrame()
{
  switch (g_hmi_CurrentFrame)
  {
	case 1: hmi_FreeFrameWidgets1(); break;
	case 2: hmi_FreeFrameWidgets2(); break;
	case 3: hmi_FreeFrameWidgets3(); break;
	case 4: hmi_FreeFrameWidgets4(); break;
	case 5: hmi_FreeFrameWidgets5(); break;
  }
}

void hmi_GetActiveFrame(char* str, unsigned int len)
{
 int FNLen = strlen(g_FrameNames[g_hmi_CurrentFrame-1]);
 if(len >= FNLen)
 memcpy(str, g_FrameNames[g_hmi_CurrentFrame-1], FNLen);
}

void hmi_GotoFrame(int nFrame)
{

  switch(nFrame)
  {
	case 1: hmi_Frame1(); break;
	case 2: hmi_Frame2(); break;
	case 3: hmi_Frame3(); break;
	case 4: hmi_Frame4(); break;
	case 5: hmi_Frame5(); break;
  }

  WidgetMessageQueueClear();
  WidgetPaint(WIDGET_ROOT);
}

int hmi_IndexOfFrame(const char *frame_name)
{
   int i;
   for (i=0; i<g_FrameCount; i++)
      if (strcmp(frame_name, g_FrameNames[i]) == 0) return i+1;
   return 0;
}


void hmi_GotoFrameByName(const char *frame_name)
{
   hmi_GotoFrame(hmi_IndexOfFrame(frame_name));
}

long hmi_Ladder_Process(tWidget *pWidget, unsigned long ulMessage,
                     unsigned long ulParam1, unsigned long ulParam2)

{
  ladder_main(1);
  passDataThruBindingOnChange();
  default_output(1);
  return 1;
}


BYTE polling_PM_2133_1(BYTE en)
{
  if ( !VAR_VALUE(PM_2133_1_ENABLE_DEVICE) ) return 0;

  return 0;
}


void hmi_Connection_Process0(void)
{
  if (PM_2133_1_flag)
  {
    VAR_SET(PM_2133_1_ERROR, polling_PM_2133_1(1)? 1:0);
    PM_2133_1_flag = false ;
  }
}

BYTE Polling_Get_Error_State(BYTE en, tHandle mtconn, sMTMaster* mtmdev)
{
  mtmdev->preerrsta = mtmdev->errsta;
  switch (hmi_TCPState(mtconn))
  {
  default:
  case STATE_TCP_IDLE:
    mtmdev->errsta = 1;
    break;
  case STATE_TCP_LISTEN:
    mtmdev->errsta = 1;
    break;
  case STATE_TCP_CONNECTING:
    if(g_ulTickTmrEvtTrig%(500/10) == 0){
    if (mtmdev->preerrsta == 2)
    mtmdev->errsta = 3;
    else if (mtmdev->preerrsta == 3)
    mtmdev->errsta = 2;
    else 
    {
    mtmdev->errsta = 2;
    mtmdev->preerrsta = 2;
    }
    } break;
  case STATE_TCP_CONNECTED:
    if (en > 0)
    mtmdev->errsta = 1;
    else
    mtmdev->errsta = 0;
    break;
    }
  return mtmdev->errsta;
}

void hmi_IOScan_Process(void)
{
  if ( s_hmi_tcp_inited )
  {
  } else {
  }


  static unsigned int polling_connection=0;
  switch(polling_connection++%1) {
  case 0:
  hmi_Connection_Process0(); break;

  default: break;
  } //end switch

  default_input(1);
}

void hmi_frame0()
{
  tContext sContext;
  UART = uart_Open("COM1,19200,N,8,1");
  PM_2133_1 = UART;
  
  RegisterNullWidgetMsgProc(hmi_Ladder_Process);
  
  hmi_grlib_init(HMI_GRLIB_INIT_BASIC);
  GrContextInit(&sContext, HMI_DISPLAY_DRIVER_PTR);
  hmi_GotoFrame(1);
  GrFlush(&sContext);
}
