﻿#define PORT         23
#define TIMEOUT      500
#define BUF_LEN      24

static tHandle h = INVALID_HANDLE;  // handle for TCP Communications

void BitButton15OnClick(tWidget *pWidget)   // Start
{
  if ( h > INVALID_HANDLE ) return; // already have a connection

  // Allocate a session. Check if h < 0 to prevent using another tHandle
  h = hmi_TCPNew();      //Allocate a TCP session if possible

  if ( h > INVALID_HANDLE )      // if allocating a new session successfully
  {
     LabelTextSet(&Label4, "Listening");
     hmi_TCPListen(h, PORT);
  }
  else
  {
     static char szMsg[20];
     usprintf(szMsg, "Err= %d", h);
     LabelTextSet(&Label4, szMsg);
     h = INVALID_HANDLE; // don't keep the error code in h
  }
}

void BitButton6OnClick(tWidget *pWidget)      // Stop
{
  if (h >= 0)
  {
    hmi_TCPClose(h);  //closes and deallocates a TCP session.
    h = -1;
    LabelTextSet(&Label4, "OFF");
  }
}

void Timer14OnExecute(tWidget *pWidget)       //Connection status
{
   if (hmi_TCPState(h) == STATE_TCP_LISTEN)               //gets the state of the TCP session.
   {
      LabelTextSet(&Label10, "LISTENED");
   }
   if (hmi_TCPState(h) == STATE_TCP_CONNECTED)
   {
      LabelTextSet(&Label10, "CONNECTED");
   }
   else
   {
      LabelTextSet(&Label10, "NO CONNECTED");
   }
}

void Timer9OnExecute(tWidget *pWidget) //Receiver data
{
   static unsigned char recv_buf[64];
   int ret = 0;

   if ( h == INVALID_HANDLE ) return; // server does not ready

   if (hmi_TCPState(h) == STATE_TCP_CONNECTED) // client connected
   {
      //reads data through a TCP session.
      ret = hmi_TCPReadEx(h, recv_buf, BUF_LEN, TIMEOUT);
	   LabelTextSet(&Label12, (char*)recv_buf);
		if (ret > 0)
		{
    	   //write back to the session immediately (no waiting in the queue).
		   hmi_TCPOutput(h, recv_buf, ret);
      }
   }
}