﻿
#define MAX_X              320
#define MAX_Y              240
#define PIC_WIDTH           80
#define PIC_HEIGHT          80
#define PIC_NUM             10  // Number of pictures, CRASH when wrong number!
#define PIC_BKCOLOR   ClrBlack  // Background Color
#define PIC_DELAY            8  // Delay (steps) before change position
#define CHG_DIR_BEEP         0  // Beep when change direction.

#define LCD_OFF_TIME  15 * 1000 // ms

// Clear the screen
void FScreenSaver6OnShow()
{
   hmi_SetForeground(thisContext, PIC_BKCOLOR);      // image background
   hmi_FillRect(thisContext, 0, 0, MAX_X, MAX_Y); // x1, y1, x2, y2

   // Auto off the LCD after specified time
   if ( LCD_OFF_TIME )
   {
      TimerIntervalSet(&LcdOffTimer10, LCD_OFF_TIME );  // Reset timer
      TimerEnabledSet(&LcdOffTimer10, TRUE);
   }
   else
      TimerEnabledSet(&LcdOffTimer10, FALSE);
}

void Timer9OnExecute(tWidget *pWidget)
{
   static int x =0, y = 0;
   static int ixDir=1, iyDir=1;
   static int iImage=0;
   static int iDelay=0;

   if ( iDelay++ % PIC_DELAY == 0 )
   {
      // Clear image at last x/y position
      hmi_SetForeground(thisContext, PIC_BKCOLOR); // image background
      hmi_FillRect(thisContext, x, y, x + PIC_WIDTH, y + PIC_HEIGHT); // x1, y1, x2, y2

      x += (PIC_WIDTH / 2) * ixDir;  // next x
      y += (PIC_HEIGHT / 2) * iyDir; // next y

      // check x position should be in the range
      if ( x + PIC_WIDTH > MAX_X )
      {
         x = MAX_X - PIC_WIDTH;
         ixDir = -1;
         if (CHG_DIR_BEEP)
            hmi_Beep();
      }
      if ( x < 0 )
      {
         x = 0;
         ixDir = 1;
         if (CHG_DIR_BEEP)
            hmi_Beep();
      }

      // check y position should be in the range
      if ( y + PIC_HEIGHT > MAX_Y )
      {
         y = MAX_Y - PIC_HEIGHT;
         iyDir = -1;
         if (CHG_DIR_BEEP)
            hmi_Beep();
      }
      if ( y < 0 )
      {
         y = 0;
         iyDir = 1;
         if (CHG_DIR_BEEP)
            hmi_Beep();
      }
   }

   iImage++; // next image
   // Note: Make sure the image index is not out of range of the actual number
   // of images assigned in the objec-list. Base on 0.
   hmi_DrawImage(thisContext, ObjectList11_85x80[iImage % PIC_NUM], x, y); // image idx, x, y

   //  1. build an object   => e.g. ObjectList11
   //  2. build an textbutton, and set refobject to the new object.
   //  3. the object name will be the ObjectList11_width x height
}

// Its time to turn off the LCD
void LcdOffTimer10OnExecute(tWidget *pWidget)
{
   hmi_BacklightSet(0);
   TimerEnabledSet(&LcdOffTimer10, FALSE);
}

