﻿#include "hmiworks.h"
BYTE ladder_main(BYTE);

int g_hmi_CurrentFrame = 0;

const char *g_FrameNames[] = 
{
  "Frame1",
  "Frame3",
};

const int g_FrameCount = (sizeof(g_FrameNames)/sizeof(char *));

#define MAGIC_NUM_TO_CON		472882027

HANDLE XVBus;
HANDLE Dev_1;


volatile unsigned long g_TimerTicksCount = 0;
unsigned long g_ulTickTmrEvtTrig = 0;

static volatile bool Dev_1_flag = false;

void hmi_TimerTrigger()
{
  g_TimerTicksCount++;
  
  if ((g_TimerTicksCount%(200/10)) == 0)
  Dev_1_flag = true ;
  
  if (table_init_flag && (g_TimerTicksCount%(100/10)) == 0)
  { g_ulTickTmrEvtTrig = g_TimerTicksCount;
    AddQueueMessage(0);}
  
  switch(g_hmi_CurrentFrame) {
    case 1: {
    break;
    }
    case 2: {
    break;
    }
  }
}

void hmi_FreeCurrentFrame()
{
  switch (g_hmi_CurrentFrame)
  {
	case 1: hmi_FreeFrameWidgets1(); break;
	case 2: hmi_FreeFrameWidgets2(); break;
  }
}

void hmi_GetActiveFrame(char* str, unsigned int len)
{
 int FNLen = strlen(g_FrameNames[g_hmi_CurrentFrame-1]);
 if(len >= FNLen)
 memcpy(str, g_FrameNames[g_hmi_CurrentFrame-1], FNLen);
}

void hmi_GotoFrame(int nFrame)
{

  switch(nFrame)
  {
	case 1: hmi_Frame1(); break;
	case 2: hmi_Frame3(); break;
  }

  WidgetMessageQueueClear();
  WidgetPaint(WIDGET_ROOT);
}

int hmi_IndexOfFrame(const char *frame_name)
{
   int i;
   for (i=0; i<g_FrameCount; i++)
      if (strcmp(frame_name, g_FrameNames[i]) == 0) return i+1;
   return 0;
}


void hmi_GotoFrameByName(const char *frame_name)
{
   hmi_GotoFrame(hmi_IndexOfFrame(frame_name));
}

long hmi_Ladder_Process(tWidget *pWidget, unsigned long ulMessage,
                     unsigned long ulParam1, unsigned long ulParam2)

{
  ladder_main(1);
  passDataThruBindingOnChange();
  default_output(1);
  return 1;
}


BYTE polling_Dev_1(BYTE en)
{
  if ( !VAR_VALUE(Dev_1_ENABLE_DEVICE) ) return 0;
BEGIN_FUNCTION_BLOCK();

char  v_do, v_di;
BOOL  flag ;
int   gWriteCount = 0;

uart_SetTimeout(Dev_1, 200);

if(VAR_VALUE(Dev_1_ENABLE_DO) && VAR_VALUE(Dev_1_W_ACTION))
{			
   int iWrite = 0;
   v_do   = 0;

   iWrite += VAR_GET_WRITE_BYTE(&v_do, Dev_1_DO0, 0);
   iWrite += VAR_GET_WRITE_BYTE(&v_do, Dev_1_DO1, 1);
   iWrite += VAR_GET_WRITE_BYTE(&v_do, Dev_1_DO2, 2);
   iWrite += VAR_GET_WRITE_BYTE(&v_do, Dev_1_DO3, 3);
   iWrite += VAR_GET_WRITE_BYTE(&v_do, Dev_1_DO4, 4);
   iWrite += VAR_GET_WRITE_BYTE(&v_do, Dev_1_DO5, 5);
   iWrite += VAR_GET_WRITE_BYTE(&v_do, Dev_1_DO6, 6);
   iWrite += VAR_GET_WRITE_BYTE(&v_do, Dev_1_DO7, 7);

   if ( iWrite )  // Write only when need
   {
      // Modbus RTU master API uses byte-array to send/receive data.
      flag = mrm_WriteDO(Dev_1, 1, 0, 8, &v_do);
      if (! flag) return HMI_ERROR; // failure
	  
      gWriteCount++;
   }
}

// Skip the reading (one time) if there is writing,
// this reduces the loading of the remote I/O device.
if ( gWriteCount ) return HMI_OK;


if(VAR_VALUE(Dev_1_ENABLE_DI) && VAR_VALUE(Dev_1_R_ACTION))
{
   v_di = 0;

   // Modbus RTU master API uses byte-array to send/receive data.
   flag = mrm_ReadDI(Dev_1, 1, 0, 8, &v_di);
   if (! flag) return HMI_ERROR; // failure

   VAR_SET(Dev_1_DI0, (v_di>>0) & 1);
   VAR_SET(Dev_1_DI1, (v_di>>1) & 1);
   VAR_SET(Dev_1_DI2, (v_di>>2) & 1);
   VAR_SET(Dev_1_DI3, (v_di>>3) & 1);
   VAR_SET(Dev_1_DI4, (v_di>>4) & 1);
   VAR_SET(Dev_1_DI5, (v_di>>5) & 1);
   VAR_SET(Dev_1_DI6, (v_di>>6) & 1);
   VAR_SET(Dev_1_DI7, (v_di>>7) & 1);
}

if(VAR_VALUE(Dev_1_ENABLE_DO) && VAR_VALUE(Dev_1_R_ACTION))
{
   v_do = 0;

   // Modbus RTU master API uses byte-array to send/receive data.
   flag = mrm_ReadDO(Dev_1, 1, 0, 8, &v_do);
   if (! flag) return HMI_ERROR; // failure

   VAR_SET(Dev_1_DO0, (v_do>>0) & 1);
   VAR_SET(Dev_1_DO1, (v_do>>1) & 1);
   VAR_SET(Dev_1_DO2, (v_do>>2) & 1);
   VAR_SET(Dev_1_DO3, (v_do>>3) & 1);
   VAR_SET(Dev_1_DO4, (v_do>>4) & 1);
   VAR_SET(Dev_1_DO5, (v_do>>5) & 1);
   VAR_SET(Dev_1_DO6, (v_do>>6) & 1);
   VAR_SET(Dev_1_DO7, (v_do>>7) & 1);
}

END_FUNCTION_BLOCK();

  return 0;
}


void hmi_Connection_Process0(void)
{
  if (Dev_1_flag)
  {
    VAR_SET(Dev_1_ERROR, polling_Dev_1(1)? 1:0);
    Dev_1_flag = false ;
  }
}
void hmi_IOScan_Process(void)
{
  static unsigned int polling_connection=0;
  switch(polling_connection++%1) {
  case 0:
  hmi_Connection_Process0(); break;

  default: break;
  } //end switch

  default_input(1);
}

void hmi_frame0()
{
  tContext sContext;
  XVBus = uart_Open("XVBus,115200,N,8,1");
  Dev_1 = XVBus;
  
  RegisterNullWidgetMsgProc(hmi_Ladder_Process);
  
  hmi_grlib_init(HMI_GRLIB_INIT_BASIC);
  GrContextInit(&sContext, HMI_DISPLAY_DRIVER_PTR);
  hmi_GotoFrame(1);
  GrFlush(&sContext);
}
