﻿#include "hmiworks.h"
BYTE ladder_main(BYTE);

int g_hmi_CurrentFrame = 0;
static int s_hmi_tcp_inited = 0;

const char *g_FrameNames[] = 
{
  "Frame1",
};

const int g_FrameCount = (sizeof(g_FrameNames)/sizeof(char *));

#define MAGIC_NUM_TO_CON		472882027

HANDLE SER_1;
HANDLE Dev_tM_P3R3_1;

void CheckModbus()
{
}

void _tpd_tcp_initial()
{
   if ( !lwIPLocalIPAddrGet() ) return;


   s_hmi_tcp_inited = 1;
}

volatile unsigned long g_TimerTicksCount = 0;
unsigned long g_ulTickTmrEvtTrig = 0;

static volatile bool Dev_tM_P3R3_1_flag = false;

void hmi_TimerTrigger()
{
  g_TimerTicksCount++;
  
  if ((g_TimerTicksCount%(200/10)) == 0)
  Dev_tM_P3R3_1_flag = true ;
  
  if (table_init_flag && (g_TimerTicksCount%(100/10)) == 0)
  { g_ulTickTmrEvtTrig = g_TimerTicksCount;
    AddQueueMessage(0);}
  
  if ( s_hmi_tcp_inited ) {
     if ((g_TimerTicksCount%50) == 0) CheckModbus();
  } else if ( g_TimerTicksCount > 80 )
     _tpd_tcp_initial();
  
  switch(g_hmi_CurrentFrame) {
    case 1: {
    break;
    }
  }
}

void hmi_FreeCurrentFrame()
{
  switch (g_hmi_CurrentFrame)
  {
	case 1: hmi_FreeFrameWidgets1(); break;
  }
}

void hmi_GetActiveFrame(char* str, unsigned int len)
{
 int FNLen = strlen(g_FrameNames[g_hmi_CurrentFrame-1]);
 if(len >= FNLen)
 memcpy(str, g_FrameNames[g_hmi_CurrentFrame-1], FNLen);
}

void hmi_GotoFrame(int nFrame)
{

  switch(nFrame)
  {
	case 1: hmi_Frame1(); break;
  }

  WidgetMessageQueueClear();
  WidgetPaint(WIDGET_ROOT);
}

int hmi_IndexOfFrame(const char *frame_name)
{
   int i;
   for (i=0; i<g_FrameCount; i++)
      if (strcmp(frame_name, g_FrameNames[i]) == 0) return i+1;
   return 0;
}


void hmi_GotoFrameByName(const char *frame_name)
{
   hmi_GotoFrame(hmi_IndexOfFrame(frame_name));
}

long hmi_Ladder_Process(tWidget *pWidget, unsigned long ulMessage,
                     unsigned long ulParam1, unsigned long ulParam2)

{
  ladder_main(1);
  passDataThruBindingOnChange();
  default_output(1);
  return 1;
}


BYTE polling_Dev_tM_P3R3_1(BYTE en)
{
  if ( !VAR_VALUE(Dev_tM_P3R3_1_ENABLE_DEVICE) ) return 0;
BEGIN_FUNCTION_BLOCK();

char  v_do, v_di,v_clr;
BOOL  flag ;
int   gWriteCount = 0;
WORD  recv[8]; 

uart_SetTimeout(Dev_tM_P3R3_1, 200);

if(VAR_VALUE(Dev_tM_P3R3_1_ENABLE_DO) && VAR_VALUE(Dev_tM_P3R3_1_W_ACTION))
{			
   int iWrite = 0;
   v_do   = 0;

   iWrite += VAR_GET_WRITE_BYTE(&v_do, Dev_tM_P3R3_1_DO0, 0);
   iWrite += VAR_GET_WRITE_BYTE(&v_do, Dev_tM_P3R3_1_DO1, 1);
   iWrite += VAR_GET_WRITE_BYTE(&v_do, Dev_tM_P3R3_1_DO2, 2);

   if ( iWrite )  // Write only when need
   {
      // Modbus RTU master API uses byte-array to send/receive data.
      flag = mrm_WriteDO(Dev_tM_P3R3_1, 1, 0, 3, &v_do);
      if (! flag) return HMI_ERROR; // failure
	  
      gWriteCount++;
   }
}

if(VAR_VALUE(Dev_tM_P3R3_1_ENABLE_DO) && VAR_VALUE(Dev_tM_P3R3_1_W_ACTION))
{			
   int iWrite = 0;
   v_clr   = 0;

   iWrite += VAR_GET_WRITE_BYTE(&v_clr, Dev_tM_P3R3_1_CNTCL0, 0);
   iWrite += VAR_GET_WRITE_BYTE(&v_clr, Dev_tM_P3R3_1_CNTCL1, 1);
   iWrite += VAR_GET_WRITE_BYTE(&v_clr, Dev_tM_P3R3_1_CNTCL2, 2);

   if ( iWrite )  // Write only when need
   {
      // Modbus RTU master API uses byte-array to send/receive data.
      flag = mrm_WriteDO(Dev_tM_P3R3_1, 1, 0x200, 3, &v_clr);
      if (! flag) return HMI_ERROR; // failure
	  
      gWriteCount++;
   }
}

// Skip the reading (one time) if there is writing,
// this reduces the loading of the remote I/O device.
if ( gWriteCount ) return HMI_OK;


if(VAR_VALUE(Dev_tM_P3R3_1_ENABLE_DI) && VAR_VALUE(Dev_tM_P3R3_1_R_ACTION))
{
   v_di = 0;

   // Modbus RTU master API uses byte-array to send/receive data.
   flag = mrm_ReadDI(Dev_tM_P3R3_1, 1, 0x20, 3, &v_di);
   if (! flag) return HMI_ERROR; // failure

   VAR_SET(Dev_tM_P3R3_1_DI0, (v_di>>0) & 1);
   VAR_SET(Dev_tM_P3R3_1_DI1, (v_di>>1) & 1);
   VAR_SET(Dev_tM_P3R3_1_DI2, (v_di>>2) & 1);
}

if(VAR_VALUE(Dev_tM_P3R3_1_ENABLE_DO) && VAR_VALUE(Dev_tM_P3R3_1_R_ACTION))
{
   v_do = 0;

   // Modbus RTU master API uses byte-array to send/receive data.
   flag = mrm_ReadDO(Dev_tM_P3R3_1, 1, 0, 3, &v_do);
   if (! flag) return HMI_ERROR; // failure

   VAR_SET(Dev_tM_P3R3_1_DO0, (v_do>>0) & 1);
   VAR_SET(Dev_tM_P3R3_1_DO1, (v_do>>1) & 1);
   VAR_SET(Dev_tM_P3R3_1_DO2, (v_do>>2) & 1);
}

if ( VAR_VALUE(Dev_tM_P3R3_1_ENABLE_AI) && VAR_VALUE(Dev_tM_P3R3_1_R_ACTION)) 
{ 
  memset(recv, 0, sizeof(recv));
  flag = mrm_ReadAI(Dev_tM_P3R3_1, 1, 0, 3, recv);
  
  VAR_SET(Dev_tM_P3R3_1_CNT0, recv[0]);
  VAR_SET(Dev_tM_P3R3_1_CNT1, recv[1]);
  VAR_SET(Dev_tM_P3R3_1_CNT2, recv[2]);
  
  if ( ! flag ) 
    return HMI_ERROR;
}

END_FUNCTION_BLOCK();

  return 0;
}


void hmi_Connection_Process0(void)
{
  if (Dev_tM_P3R3_1_flag)
  {
    VAR_SET(Dev_tM_P3R3_1_ERROR, polling_Dev_tM_P3R3_1(1)? 1:0);
    Dev_tM_P3R3_1_flag = false ;
  }
}

BYTE Polling_Get_Error_State(BYTE en, tHandle mtconn, sMTMaster* mtmdev)
{
  mtmdev->preerrsta = mtmdev->errsta;
  switch (hmi_TCPState(mtconn))
  {
  default:
  case STATE_TCP_IDLE:
    mtmdev->errsta = 1;
    break;
  case STATE_TCP_LISTEN:
    mtmdev->errsta = 1;
    break;
  case STATE_TCP_CONNECTING:
    if(g_ulTickTmrEvtTrig%(500/10) == 0){
    if (mtmdev->preerrsta == 2)
    mtmdev->errsta = 3;
    else if (mtmdev->preerrsta == 3)
    mtmdev->errsta = 2;
    else 
    {
    mtmdev->errsta = 2;
    mtmdev->preerrsta = 2;
    }
    } break;
  case STATE_TCP_CONNECTED:
    if (en > 0)
    mtmdev->errsta = 1;
    else
    mtmdev->errsta = 0;
    break;
    }
  return mtmdev->errsta;
}

void hmi_IOScan_Process(void)
{
  if ( s_hmi_tcp_inited )
  {
  } else {
  }


  static unsigned int polling_connection=0;
  switch(polling_connection++%1) {
  case 0:
  hmi_Connection_Process0(); break;

  default: break;
  } //end switch

  default_input(1);
}

void hmi_frame0()
{
  tContext sContext;
  SER_1 = uart_Open("COM1,9600,N,8,1");
  Dev_tM_P3R3_1 = SER_1;
  
  RegisterNullWidgetMsgProc(hmi_Ladder_Process);
  
  hmi_grlib_init(HMI_GRLIB_INIT_BASIC);
  GrContextInit(&sContext, HMI_DISPLAY_DRIVER_PTR);
  hmi_GotoFrame(1);
  GrFlush(&sContext);
}
